// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from etsi_its_denm_msgs:msg/ActionID.idl
// generated code does not contain a copyright notice
#include "etsi_its_denm_msgs/msg/detail/action_id__rosidl_typesupport_fastrtps_cpp.hpp"
#include "etsi_its_denm_msgs/msg/detail/action_id__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace etsi_its_denm_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const etsi_its_denm_msgs::msg::StationID &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  etsi_its_denm_msgs::msg::StationID &);
size_t get_serialized_size(
  const etsi_its_denm_msgs::msg::StationID &,
  size_t current_alignment);
size_t
max_serialized_size_StationID(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace etsi_its_denm_msgs

namespace etsi_its_denm_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const etsi_its_denm_msgs::msg::SequenceNumber &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  etsi_its_denm_msgs::msg::SequenceNumber &);
size_t get_serialized_size(
  const etsi_its_denm_msgs::msg::SequenceNumber &,
  size_t current_alignment);
size_t
max_serialized_size_SequenceNumber(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace etsi_its_denm_msgs


namespace etsi_its_denm_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_etsi_its_denm_msgs
cdr_serialize(
  const etsi_its_denm_msgs::msg::ActionID & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: originating_station_id
  etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.originating_station_id,
    cdr);
  // Member: sequence_number
  etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.sequence_number,
    cdr);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_etsi_its_denm_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  etsi_its_denm_msgs::msg::ActionID & ros_message)
{
  // Member: originating_station_id
  etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.originating_station_id);

  // Member: sequence_number
  etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.sequence_number);

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_etsi_its_denm_msgs
get_serialized_size(
  const etsi_its_denm_msgs::msg::ActionID & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: originating_station_id

  current_alignment +=
    etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.originating_station_id, current_alignment);
  // Member: sequence_number

  current_alignment +=
    etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.sequence_number, current_alignment);

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_etsi_its_denm_msgs
max_serialized_size_ActionID(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: originating_station_id
  {
    size_t array_size = 1;


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_StationID(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  // Member: sequence_number
  {
    size_t array_size = 1;


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_SequenceNumber(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = etsi_its_denm_msgs::msg::ActionID;
    is_plain =
      (
      offsetof(DataType, sequence_number) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static bool _ActionID__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const etsi_its_denm_msgs::msg::ActionID *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _ActionID__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<etsi_its_denm_msgs::msg::ActionID *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _ActionID__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const etsi_its_denm_msgs::msg::ActionID *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _ActionID__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_ActionID(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _ActionID__callbacks = {
  "etsi_its_denm_msgs::msg",
  "ActionID",
  _ActionID__cdr_serialize,
  _ActionID__cdr_deserialize,
  _ActionID__get_serialized_size,
  _ActionID__max_serialized_size
};

static rosidl_message_type_support_t _ActionID__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_ActionID__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace etsi_its_denm_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_etsi_its_denm_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<etsi_its_denm_msgs::msg::ActionID>()
{
  return &etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::_ActionID__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, etsi_its_denm_msgs, msg, ActionID)() {
  return &etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::_ActionID__handle;
}

#ifdef __cplusplus
}
#endif
