// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from etsi_its_denm_msgs:msg/EventPoint.idl
// generated code does not contain a copyright notice
#include "etsi_its_denm_msgs/msg/detail/event_point__rosidl_typesupport_fastrtps_cpp.hpp"
#include "etsi_its_denm_msgs/msg/detail/event_point__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace etsi_its_denm_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const etsi_its_denm_msgs::msg::DeltaReferencePosition &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  etsi_its_denm_msgs::msg::DeltaReferencePosition &);
size_t get_serialized_size(
  const etsi_its_denm_msgs::msg::DeltaReferencePosition &,
  size_t current_alignment);
size_t
max_serialized_size_DeltaReferencePosition(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace etsi_its_denm_msgs

namespace etsi_its_denm_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const etsi_its_denm_msgs::msg::PathDeltaTime &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  etsi_its_denm_msgs::msg::PathDeltaTime &);
size_t get_serialized_size(
  const etsi_its_denm_msgs::msg::PathDeltaTime &,
  size_t current_alignment);
size_t
max_serialized_size_PathDeltaTime(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace etsi_its_denm_msgs

namespace etsi_its_denm_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const etsi_its_denm_msgs::msg::InformationQuality &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  etsi_its_denm_msgs::msg::InformationQuality &);
size_t get_serialized_size(
  const etsi_its_denm_msgs::msg::InformationQuality &,
  size_t current_alignment);
size_t
max_serialized_size_InformationQuality(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace etsi_its_denm_msgs


namespace etsi_its_denm_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_etsi_its_denm_msgs
cdr_serialize(
  const etsi_its_denm_msgs::msg::EventPoint & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: event_position
  etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.event_position,
    cdr);
  // Member: event_delta_time
  etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.event_delta_time,
    cdr);
  // Member: event_delta_time_is_present
  cdr << (ros_message.event_delta_time_is_present ? true : false);
  // Member: information_quality
  etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.information_quality,
    cdr);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_etsi_its_denm_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  etsi_its_denm_msgs::msg::EventPoint & ros_message)
{
  // Member: event_position
  etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.event_position);

  // Member: event_delta_time
  etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.event_delta_time);

  // Member: event_delta_time_is_present
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.event_delta_time_is_present = tmp ? true : false;
  }

  // Member: information_quality
  etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.information_quality);

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_etsi_its_denm_msgs
get_serialized_size(
  const etsi_its_denm_msgs::msg::EventPoint & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: event_position

  current_alignment +=
    etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.event_position, current_alignment);
  // Member: event_delta_time

  current_alignment +=
    etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.event_delta_time, current_alignment);
  // Member: event_delta_time_is_present
  {
    size_t item_size = sizeof(ros_message.event_delta_time_is_present);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: information_quality

  current_alignment +=
    etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.information_quality, current_alignment);

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_etsi_its_denm_msgs
max_serialized_size_EventPoint(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: event_position
  {
    size_t array_size = 1;


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_DeltaReferencePosition(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  // Member: event_delta_time
  {
    size_t array_size = 1;


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_PathDeltaTime(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  // Member: event_delta_time_is_present
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: information_quality
  {
    size_t array_size = 1;


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_InformationQuality(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = etsi_its_denm_msgs::msg::EventPoint;
    is_plain =
      (
      offsetof(DataType, information_quality) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static bool _EventPoint__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const etsi_its_denm_msgs::msg::EventPoint *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _EventPoint__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<etsi_its_denm_msgs::msg::EventPoint *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _EventPoint__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const etsi_its_denm_msgs::msg::EventPoint *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _EventPoint__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_EventPoint(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _EventPoint__callbacks = {
  "etsi_its_denm_msgs::msg",
  "EventPoint",
  _EventPoint__cdr_serialize,
  _EventPoint__cdr_deserialize,
  _EventPoint__get_serialized_size,
  _EventPoint__max_serialized_size
};

static rosidl_message_type_support_t _EventPoint__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_EventPoint__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace etsi_its_denm_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_etsi_its_denm_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<etsi_its_denm_msgs::msg::EventPoint>()
{
  return &etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::_EventPoint__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, etsi_its_denm_msgs, msg, EventPoint)() {
  return &etsi_its_denm_msgs::msg::typesupport_fastrtps_cpp::_EventPoint__handle;
}

#ifdef __cplusplus
}
#endif
